;compiler: avrasm
	;@1 <= (signed(@0)*signed(@0))<<1
	;32 <= 16*16
	;using @2 as zero reg
	.macro	pwrsw
	fmuls	@0H,@0H
	movw	@1B3,R0
	fmul	@0,@0
	adc	@1B3,@2
	movw	@1,R0
	fmulsu	@0H,@0
	brcc	PC+1+1+1
	dec	@1B4
	dec	@1B4
	add	@1H,R0
	adc	@1B3,R1
	adc	@1B4,@2
	add	@1H,R0
	adc	@1B3,R1
	adc	@1B4,@2
	.endm
	
	;@2 <= (signed(@0)*signed(@1))<<1
	;32 <= (16*16)<<1
	;using @3 as zero reg
	.macro	fmulsw
	fmuls	@0H,@1H
	movw	@2B3,R0
	fmul	@0,@1
	adc	@2B3,@3
	movw	@2,R0
	fmulsu	@0H,@1
	sbc	@2B4,@3
	add	@2H,R0
	adc	@2B3,R1
	adc	@2B4,@3
	fmulsu	@1H,@0
	sbc	@2B4,@3
	add	@2H,R0
	adc	@2B3,R1
	adc	@2B4,@3	
	.endm
	
	;@2 <= signed(@0)*signed(@1)
	;32 <= 16*16
	;using @3 as zero reg
	.macro	mulsw
	muls	@0H,@1H
	movw	@2B3,R0
	mul	@0,@1
	movw	@2,R0
	mulsu	@0H,@1
	sbc	@2B4,@3
	add	@2H,R0
	adc	@2B3,R1
	adc	@2B4,@3
	mulsu	@1H,@0
	sbc	@2B4,@3
	add	@2H,R0
	adc	@2B3,R1
	adc	@2B4,@3	
	.endm
	
	;@2 <= signed(@0)*unsigned(@1)
	;32 <= 16*16
	;using @3 as zero reg
	.macro	mulsuw
	mulsu	@0H,@1H
	movw	@2B3,R0
	mul	@0,@1
	movw	@2,R0
	mulsu	@0H,@1
	sbc	@2B4,@3
	add	@2H,R0
	adc	@2B3,R1
	adc	@2B4,@3
	mul	@1H,@0
	add	@2H,R0
	adc	@2B3,R1
	adc	@2B4,@3	
	.endm

	;signed(@5:@6) <= signed(@0)*signed(@1) - signed(@2)*unsigned(@3)
	;32 <= 16*16 - 16*16
	;using @7 as zero reg, and changing @6 register PAIR 
	.macro	msubw
	muls	@0H,@1H
	movw	@5,R0
	mulsu	@2H,@3H	;
	movw	@6,R0
	mul	@0,@1
	movw	@4,R0
	mul	@2,@3	;
	sub	@4,R0
	sbc	@4H,R1
	sbc	@5,@6
	sbc	@5H,@6H
	mulsu	@0H,@1
	sbc	@5H,@7
	add	@4H,R0
	adc	@5,R1
	adc	@5H,@7
	mulsu	@2H,@3	;
	adc	@5H,@7
	sub	@4H,R0
	sbc	@5,R1
	sbc	@5H,@7
	mulsu	@1H,@0
	sbc	@5H,@7
	add	@4H,R0
	adc	@5,R1
	adc	@5H,@7
	mul	@3H,@2	;
	sub	@4H,R0
	sbc	@5,R1
	sbc	@5H,@7
	.endm
	
	;signed(@5:@6) <= signed(@0)*signed(@1) + signed(@2)*unsigned(@3)
	;32 <= 16*16 + 16*16
	;using @7 as zero reg, and changing @6 register PAIR
	.macro	maddw
	muls	@0H,@1H
	movw	@5,R0
	mulsu	@2H,@3H	;
	movw	@6,R0
	mul	@0,@1
	movw	@4,R0
	mul	@2,@3	;
	add	@4,R0
	adc	@4H,R1
	adc	@5,@6
	adc	@5H,@6H
	mulsu	@0H,@1
	sbc	@5H,@7
	add	@4H,R0
	adc	@5,R1
	adc	@5H,@7
	mulsu	@2H,@3	;
	sbc	@5H,@7
	add	@4H,R0
	adc	@5,R1
	adc	@5H,@7
	mulsu	@1H,@0
	sbc	@5H,@7
	add	@4H,R0
	adc	@5,R1
	adc	@5H,@7
	mul	@3H,@2	;
	add	@4H,R0
	adc	@5,R1
	adc	@5H,@7
	.endm
	
	
;------------------------------------------------------------------------------------------------
;	simplified butterfly algorithm, called from "FFTditr2"
;	algorithm is optimized for ang=0 where original algorithm: 
;	A_new <= A_old + Fki*B_old
;	B_new <= A_old - Fki*B_old
;	
;	can be simplified as:
;	A_new <= A_old + B_old
;	B_new <= A_old - B_old
;------------------------------------------------------------------------------------------------
	.equ	FFTditr2a0Mp=1	;allow signed correction
	
	.macro	FFTditr2a0M
	mov	R13,R15	;butter fly counter
	;--- for each butterfly ---
FFTditr2a0ML:	ld	R8,X+
	ld	R9,X+
	asr	R9
	ror	R8	;Rre=re{*X}>>1
	.if	FFTprec==1 && FFTditr2a0Mp==1
	tst	R9
	brpl	PC+1+1+1
	adc	R8,R2
	adc	R9,R2
	.endif
	ld	R6,X+
	ld	R7,X+
	asr	R7
	ror	R6	;Rim=im{*X}>>1
	.if	FFTprec==1 && FFTditr2a0Mp==1
	tst	R7
	brpl	PC+1+1+1
	adc	R6,R2
	adc	R7,R2
	.endif
	ldd	R16,Y+0
	ldd	R17,Y+1
	asr	R17
	ror	R16	;Are=re{*Y}>>1
	.if	FFTprec==1 && FFTditr2a0Mp==1
	tst	R17
	brpl	PC+1+1+1
	adc	R16,R2
	adc	R17,R2
	.endif
	ldd	R18,Y+2
	ldd	R19,Y+3
	asr	R19
	ror	R18	;Aim=im{*Y}>>1
	.if	FFTprec==1 && FFTditr2a0Mp==1
	tst	R19
	brpl	PC+1+1+1
	adc	R18,R2
	adc	R19,R2
	.endif
	movw	R4,R16
	movw	R10,R18	;backup Are,Aim
	;A output
	add	R16,R8
	adc	R17,R9
	std	Y+0,R16
	std	Y+1,R17	;re{*Y}=Are+Rre
	add	R18,R6
	adc	R19,R7
	std	Y+2,R18
	std	Y+3,R19	;im{*y}=Aim+Rim
	;B output
	sub	R10,R6
	sbc	R11,R7
	st	-X,R11
	st	-X,R10	;im{*X}=Aim-Rim
	sub	R4,R8
	sbc	R5,R9
	st	-X,R5
	st	-X,R4	;re{*X}=Are-Rre
	;move input pointers to next butterfly inputs
	add	R28,R24
	adc	R29,R25	;Y+=2*n
	add	R26,R24
	adc	R27,R25	;X+=2*n
	dec	R13
	brne	FFTditr2a0ML	;next butterfly	
	.endm
	
	
;------------------------------------------------------------------------------------------------
;	simplified butterfly algorithm, called from "FFTditr2"
;	algorithm is optimized for ang=pi/2 where original algorithm: 
;	A_new <= A_old + Fki*B_old
;	B_new <= A_old - Fki*B_old
;	
;	can be simplified as:
;	re{A_new} <= re{A_old} - im{B_old}
;	im{A_new} <= im{A_old} + re{B_old}
;	re{B_new} <= re{A_old} + im{B_old}
;	im{B_new} <= im{A_old} - re{B_old}
;------------------------------------------------------------------------------------------------
	.equ	FFTditr2api2Mp=1	;allow signed corection
	
	.macro	FFTditr2api2M
	mov	R13,R15	;butter fly counter
	;--- for each butterfly ---
FFTditr2api2ML:	ld	R8,X+
	ld	R9,X+
	asr	R9
	ror	R8	;Rre=re{*X}>>1
	.if	FFTprec==1 && FFTditr2api2Mp==1
	tst	R9
	brpl	PC+1+1+1
	adc	R8,R2
	adc	R9,R2
	.endif
	ld	R6,X+
	ld	R7,X+
	asr	R7	
	ror	R6	;Rim=im{*X}>>1
	.if	FFTprec==1 && FFTditr2api2Mp==1
	tst	R7
	brpl	PC+1+1+1
	adc	R6,R2
	adc	R7,R2
	.endif
	ldd	R16,Y+0
	ldd	R17,Y+1
	asr	R17
	ror	R16	;Are=re{*Y}>>1
	.if	FFTprec==1 && FFTditr2api2Mp==1
	tst	R17
	brpl	PC+1+1+1
	adc	R16,R2
	adc	R17,R2
	.endif
	ldd	R18,Y+2
	ldd	R19,Y+3
	asr	R19	
	ror	R18	;Aim=im{*Y}>>1
	.if	FFTprec==1 && FFTditr2api2Mp==1
	tst	R19
	brpl	PC+1+1+1
	adc	R18,R2
	adc	R19,R2
	.endif
	movw	R4,R16
	movw	R10,R18	;backup Are,Aim
	;A output
	sub	R16,R6
	sbc	R17,R7
	std	Y+0,R16	
	std	Y+1,R17	;re{*Y}=Are-Rim
	add	R18,R8
	adc	R19,R9
	std	Y+2,R18
	std	Y+3,R19	;im{*y}=Aim+Rre
	;B output
	sub	R10,R8
	sbc	R11,R9
	st	-X,R11
	st	-X,R10	;im{*X}=Aim-Rre
	add	R4,R6
	adc	R5,R7
	st	-X,R5
	st	-X,R4	;re{*X}=Are+Rim
	;move input pointers to next butterfly inputs
	add	R28,R24
	adc	R29,R25	;Y+=2*n
	add	R26,R24
	adc	R27,R25	;X+=2*n
	dec	R13
	brne	FFTditr2api2ML	;next butterfly	
	.endm
		
