#ifndef MAIN_H
#define MAIN_H

// --- signals definitions (there are also some unused peripherals on breadboard) ---
// portd signals
#define IORD 3
#define IOWR 7
#define ROE 4
#define RMA 6
#define RHA 5
#define BCO 2

// portb signals
#define DWS 2
#define DCK 7
#define DCTS 4
#define DDT 5
#define RWR 3
#define LRS 1
#define LCK 0



#ifndef __ASSEMBLER__


// wave playback structure
typedef struct{
	uint32_t tord;
	uint16_t rate;
	uint8_t chn;
	uint8_t bit;
	uint8_t be;
}TWave;



// ====== Timeout ======
extern volatile uint8_t to_cnt;

// config
#define to_config() \
{ \
	TCCR1A=0; \
	TCCR1B=1<<WGM12|1<<CS10|1<<CS12; \
}

// check timout
#define to_test() (to_cnt==0)

// enable timeout timer
#define to_run() TIMSK1|=1<<OCIE1A

// stop timeout timer
#define to_stop() TIMSK1&=~(1<<OCIE1A)

// set interval
#define to_time(to_time_int) OCR1A=(unsigned int)(((unsigned long)F_CPU>>10)*(unsigned long)(to_time_int)/10000u)

// reset timer
#define to_reset() \
{ \
	TCNT1=0; \
	to_cnt=10; \
}


#endif
#endif
