#ifndef SERIAL_H
#define SERIAL_H

// CTS control
#define rx_cts_set() PORTB&=~(1<<DCTS)
#define rx_cts_clr() PORTB|=(1<<DCTS)

// ------ configurate USART ------
#define serial_config(sc_div) \
{ \
	UCSR0A=1<<U2X0; \
	UCSR0B=1<<RXEN0|1<<TXEN0; \
	UCSR0C=1<<UCSZ00|1<<UCSZ01; \
	UBRR0=sc_div; \
}

// --- riff data reciever ---
// N bytes
#define RX_RIFF_N 128
// start offset in FIFO buffer
#define RX_RIFF_OFS (4*RX_RIFF_N)
extern int8_t rx_riff(void);

// --- other externals ---
extern void rx_flush(void);
extern void rx_discard(void);
extern void tx_str_P(PGM_P str);
extern void tx_str(char *str);


#endif
