#ifndef SOUND_H
#define SOUND_H

// audio FIFO size (must be multiple of 4)
#define FIFOsize 3600

// bus type (1543 for I2S, 1545 for TDA1545)
#define DAC 1543




#ifndef __ASSEMBLER__

// globals
extern uint8_t FIFO[FIFOsize];
extern uint8_t FIFOpref;
extern volatile uint8_t *FIFOrd;
extern uint8_t *FIFOwr;



// start output
#define I2S_run() TIMSK0|=1<<OCIE0A

// stop output
#define I2S_stop() TIMSK0&=~(1<<OCIE0A)

// external fuction prototypes
extern void I2S_config(uint16_t srate);
extern void I2S_set_read(uint8_t *rd);
extern void I2S_clear(void);
extern void I2S_clear_sync(void);

#endif
#endif
