;compiler: avrasm
;testovaci program pro radic LCD PG320240WRM-HNNIS3
;XTAL 16MHz 

	.include "m32def.inc"
	.dseg
WorkLineBuffer:	.byte	640	;pracovni buffer pro jednu lajnu textu
WorkLineBufPTR:	.byte	2	;ukazatel posledni pozice v lajne
TempBuffer:	.byte	320	;temp buffer
TPcalTemp:	.byte	8	;kalibracni konstanty
TPxVal:	.byte	2	;x souradnice touchscreenu
TPyVal:	.byte	2	;y souradnice touchscreenu
TPxValReal:	.byte	2	;totez bez korekce
TPyValReal:	.byte	2	;totez bez korekce
RDbufferID:	.byte	1	;ID bufferu pro zobrazeni
WRbufferID:	.byte	1	;ID bufferu pro zapis

	.cseg
	.org	0x0000
	rjmp	Init
	
	;porta
	.equ	RS=0	;vystup
	.equ	DCKOUT=1	;vstup
	.equ	DCKIN=2	;vystup
	
	;start programu	
Init:	ldi	R16,0b00000101
	out	ddra,R16
	ldi	R16,0b00000000
	out	ddrb,R16
	ldi	R16,0b11111111
	out	ddrc,R16
	ldi	R16,0b00000000
	out	ddrd,R16	;definice smeru pinu
	
	sbi	porta,DCKIN	;CKIN do log.1
	
	ldi	R16,low(ramend)
	ldi	R17,high(ramend)
	out	sph,R17
	out	spl,R16	;stack na konec RAM
	
	ldi	R16,50
	rcall	DelayLongVar	;nejdriv pockat na rozbeh radice LCD
	
	ldi	R16,low(150)
	ldi	R17,high(150)
	rcall	LCDsetMfreq	;M frekvence na 150Hz
	
	ldi	R16,7
	rcall	LCDsetContrast	;kontrast nastavit nekam na stred
	
	;nastavit touch screen
	ldi	R16,5
	rcall	DsetTSfCycles	;nastavit pocet hodnot v toleranci
	ldi	R16,3
	rcall	DsetTSfMaxDiff	;jejich maxiamlni odchylku
	ldi	R16,5
	rcall	DsetTSfDelay	;a zpozdeni vymazu souradnic po uvolneni stisku

	ldi	R16,low(95)
	ldi	R17,high(95)	;hodnota AD prevodniku pro stisk vlevo
	ldi	R18,low(112)
	ldi	R19,high(112)	;hodnota AD prevodniku pro stisk nahore
	ldi	R20,low(929)
	ldi	R21,high(929)	;hodnota AD prevodniku pro stisk vpravo
	ldi	R22,low(908)
	ldi	R23,high(908)	;hodnota AD prevodniku pro stisk dole
	sts	TPcalTemp+0,R16
	sts	TPcalTemp+1,R17
	sts	TPcalTemp+2,R18
	sts	TPcalTemp+3,R19
	sts	TPcalTemp+4,R20
	sts	TPcalTemp+5,R21
	sts	TPcalTemp+6,R22
	sts	TPcalTemp+7,R23
	rcall	DsetTScalConst	;nastavit kalibracni konstanty pro touchscreen
	
	ldi	R16,0
	sts	RDbufferID,R16	;0. cteci buffer
	ldi	R16,1
	sts	WRbufferID,R16	;1. buffer pro zapis
	
	
	;smycka, kde se generuje obraz
Loop:	lds	R16,WRbufferID
	rcall	LCDsetWRbuffer	;nastavit buffer pro zapis dat
	lds	R16,RDbufferID
	rcall	LCDsetRDbuffer	;nastavit buffer pro zobrazovani

	rcall	LCDclrScrW	;smazat LCD
	
	ldi	R16,low(0)
	ldi	R17,high(0)
	rcall	LCDbuffSetPos	;pozice na LCD ma 0,0
	rcall	ClrLineBuffer
	ldi	R30,low(TextT1T*2)
	ldi	R31,high(TextT1T*2)
	rcall	LCDwrStrFlash16
	rcall	TxDataBuffer	;nejakej text
	
	ldi	R16,low(1*640)
	ldi	R17,high(1*640)
	rcall	LCDbuffSetPos	;pozice na LCD ma 0,1
	rcall	ClrLineBuffer
	ldi	R30,low(TextT2T*2)
	ldi	R31,high(TextT2T*2)
	rcall	LCDwrStrFlash16
	rcall	TxDataBuffer	;nejakej text
	
	ldi	R16,low(5*640+5)
	ldi	R17,high(5*640+5)
	rcall	LCDbuffSetPos	;pozice na LCD
	rcall	ClrLineBuffer
	ldi	R30,low(TextMNT*2)
	ldi	R31,high(TextMNT*2)
	rcall	LCDwrStrFlash16
	rcall	TxDataBuffer	;nejakej text
	
	ldi	R16,low(7*640+16)
	ldi	R17,high(7*640+16)
	rcall	LCDbuffSetPos	;pozice na LCD
	rcall	ClrLineBuffer
	ldi	R30,low(TextDatumT*2)
	ldi	R31,high(TextDatumT*2)
	rcall	LCDwrStrFlash16
	rcall	TxDataBuffer	;nejakej text
	
	rcall	DgetTPxy	;nacist XY touchscreenu
	
	ldi	R16,low(13*640)
	ldi	R17,high(13*640)
	rcall	LCDbuffSetPos	;pozice na zacatek radku 13 (pro 16pix font) 
	rcall	ClrLineBuffer
	ldi	R30,low(TextXposT*2)
	ldi	R31,high(TextXposT*2)
	rcall	LCDwrStrFlash16	;napis x pozice
	lds	R16,TPxVal+0
	lds	R17,TPxVal+1
	rcall	bin2BCD16p5	;prevod binarniho cisla do textu
	rcall	LCDwrBCDcom	;vypsat text
	rcall	TxDataBuffer	;zase odeslat
	
	ldi	R16,low(14*640)
	ldi	R17,high(14*640)
	rcall	LCDbuffSetPos	;pozice na zacatek radku 13 (pro 16pix font)
	rcall	ClrLineBuffer
	ldi	R30,low(TextYposT*2)
	ldi	R31,high(TextYposT*2)
	rcall	LCDwrStrFlash16
	lds	R16,TPyVal+0
	lds	R17,TPyVal+1
	rcall	bin2BCD16p5	;prevod binarniho cisla do textu
	rcall	LCDwrBCDcom	;vypsat text
	rcall	TxDataBuffer	;odeslat radek
		
	rcall	DrawXYpos	;ted vykreslit souradnicovy kriz
	
	ldi	R16,1
	rcall	DelayLongVar	;nejaky zpozdeni
	
	ldi	R17,0b00000001
	lds	R16,RDbufferID
	eor	R16,R17
	sts	RDbufferID,R16
	lds	R16,WRbufferID
	eor	R16,R17
	sts	WRbufferID,R16	;ted prehodit buffery cteni a zapisu kvuli dvojitymu buffrovani
		
	rjmp	Loop
	
	
	;vykreslit souradnicovy kriz
DrawXYpos:	lds	R16,TPxVal+0
	lds	R17,TPxVal+1
	lds	R18,TPyVal+0
	lds	R19,TPyVal+1
	ldi	R20,0xFF
	cp	R16,R20
	cpc	R17,R20
	cpc	R18,R20
	cpc	R19,R20
	brne	DrawXYposC
	ret
DrawXYposC:	;folie stisknuta, kreslit vertikalni linku
	clr	R15
	lsr	R17
	ror	R16
	ror	R15
	lsr	R17
	ror	R16
	ror	R15
	lsr	R17
	ror	R16
	ror	R15
	swap	R15
	lsr	R15	;ID masky
	movw	R24,R16	;pozice

	ldi	R16,0b10000000
	mov	R17,R15
	cpi	R17,0
	breq	DXYPn1
DXYPn2:	lsr	R16	;vytvorit masku
	dec	R17
	brne	DXYPn2
DXYPn1:	com	R16
	mov	R26,R16
	ser	R27
	
	ldi	R23,240
	
LCL1DataRDl1:	movw	R16,R24
	rcall	LCDbuffSetPos
		
	out	portc,R26	;byte ven
	cbi	porta,DCKIN	;oznamit data na drate
LCL1DataRDack15:	sbic	pina,DCKOUT	;cekat na potvrzeni prijmu
	rjmp	LCL1DataRDack15
	out	portc,R27	;dalsi byte ven
	sbi	porta,DCKIN	;oznamit dalsi data na drate
LCL1DataRDack25:	sbis	pina,DCKOUT
	rjmp	LCL1DataRDack25
	
	adiw	R24,40
	dec	R23
	brne	LCL1DataRDl1	;kreslit caru
	;ted horizontalni linka
	lds	R16,TPyVal
	ldi	R17,40
	mul	R16,R17
	movw	R16,R0
	rcall	LCDbuffSetPos	;odeslat pozici zacatku
	ldi	R26,0b00000000
	
	ldi	R23,20
	
LCL1DataRDl2:	out	portc,R26	;byte ven
	cbi	porta,DCKIN	;oznamit data na drate
LCL2DataRDack15:	sbic	pina,DCKOUT	;cekat na potvrzeni prijmu
	rjmp	LCL2DataRDack15
	out	portc,R26	;dalsi byte ven
	sbi	porta,DCKIN	;oznamit dalsi data na drate
LCL2DataRDack25:	sbis	pina,DCKOUT
	rjmp	LCL2DataRDack25
	
	dec	R23
	brne	LCL1DataRDl2	;vykreslit
	
	ret
;*******************************************************************************************
;	texty
;*******************************************************************************************	
TextT1T:	.db	" Testovac program pro adi displeje PG320240WRM-HNNIS3.",0xFF	
TextT2T:	.db	" Stiskem dotykov flie se zobraz vyhodnocen pozice.",0xFF
TextMNT:	.db	" ",169," Stanislav Mal       s.maslan@seznam.cz",0xFF
TextDatumT:	.db	" 18.7.2006",0xFF
TextXposT:	.db	" Stisk X: ",0xFF
TextYposT:	.db	" Stisk Y: ",0xFF	
;*******************************************************************************************
;	komunikace s modulem LCD
;*******************************************************************************************	
;--------------------------------------------------------------------------------------------
;	nastavit M frekvenci (R16:R17)
;--------------------------------------------------------------------------------------------
LCDsetMfreq:	movw	R18,R16	;parametry
	ldi	R16,0x0A	;kod instrukce
	rcall	LCDtxInstrCom
	ret
;--------------------------------------------------------------------------------------------
;	nastavit kontrast (R16)
;--------------------------------------------------------------------------------------------
LCDsetContrast:	mov	R18,R16	;parametry
	clr	R19
	ldi	R16,0x0C	;kod instrukce
	rcall	LCDtxInstrCom
	ret
;--------------------------------------------------------------------------------------------
;	nastavit zobrazovaci buffer (R16=0..2)
;--------------------------------------------------------------------------------------------
LCDsetRDbuffer:	mov	R18,R16
	clr	R19
	ldi	R16,0x01	;kod instrukce
	rcall	LCDtxInstrCom
	ret
;--------------------------------------------------------------------------------------------
;	nastavit buffer pro zapis (R16=0..2)
;--------------------------------------------------------------------------------------------
LCDsetWRbuffer:	mov	R18,R16
	clr	R19
	ldi	R16,0x02	;kod instrukce
	rcall	LCDtxInstrCom
	ret
;--------------------------------------------------------------------------------------------	
;	odeslat kalibracni konstanty TouchScreenu LCD radici
;--------------------------------------------------------------------------------------------
DsetTScalConst:	ldi	R30,low(TPcalTemp)
	ldi	R31,high(TPcalTemp)
	ldi	R20,4	;odeslat vsechny kalibracni konstanty
	ldi	R16,0x18	;prvni instrukce
DsetTScalCL1:	ld	R18,Z+
	ld	R19,Z+
	rcall	LCDtxInstrCom
	inc	R16
	dec	R20
	brne	DsetTScalCL1
	ret
;--------------------------------------------------------------------------------------------
;	nastavit adresu zapisu na LCD
;--------------------------------------------------------------------------------------------
LCDbuffSetPos:	push	R18
	push	R19
	movw	R18,R16	;parametry
	ldi	R16,0x00	;kod instrukce
	rcall	LCDtxInstrCom
	pop	R19
	pop	R18	
	ret
;--------------------------------------------------------------------------------------------
;	nastavit pocet cyklu pro filtr touchscreenu (R16)
;--------------------------------------------------------------------------------------------
DsetTSfCycles:	mov	R18,R16
	ldi	R16,0x16	;kod instrukce
	rcall	LCDtxInstrCom
	ret
;--------------------------------------------------------------------------------------------
;	nastavi max odchylku filtru 2 mereni pro touchscreen (R16)
;--------------------------------------------------------------------------------------------
DsetTSfMaxDiff:	mov	R18,R16
	ldi	R16,0x17	;kod instrukce
	rcall	LCDtxInstrCom
	ret
;--------------------------------------------------------------------------------------------
;	nastavit zpozdeni vymazani souradnic stisku po uvolneni dotyku (R16)
;--------------------------------------------------------------------------------------------
DsetTSfDelay:	mov	R18,R16
	ldi	R16,0x1D	;kod instrukce
	rcall	LCDtxInstrCom
	ret
;--------------------------------------------------------------------------------------------
;	nacist XY touchscreenu korigovane, filtrovane filtrovane
;--------------------------------------------------------------------------------------------
DgetTPxy:	ldi	R16,0x12
	rcall	LCDtrxInstrCom
	sts	TPxVal+0,R16
	sts	TPxVal+1,R17
	ldi	R16,0x13
	rcall	LCDtrxInstrCom
	sts	TPyVal+0,R16
	sts	TPyVal+1,R17
	ret
;--------------------------------------------------------------------------------------------
;	nacist XY TS nefiltrovane, nekorigovane
;--------------------------------------------------------------------------------------------	
DgetTPxyReal:	ldi	R16,0x14
	rcall	LCDtrxInstrCom
	sts	TPxValReal+0,R16
	sts	TPxValReal+1,R17
	ldi	R16,0x15
	rcall	LCDtrxInstrCom
	sts	TPyValReal+0,R16
	sts	TPyValReal+1,R17
	ret
;--------------------------------------------------------------------------------------------
;	odeslat instrukci modulu LCD (byty R16:R17:R18:R19)
;--------------------------------------------------------------------------------------------
LCDtxInstrCom:	cbi	porta,RS
	;
	out	portc,R16
	cbi	porta,DCKIN
WaitInstrACK1:	sbic	pina,DCKOUT
	rjmp	WaitInstrACK1
	out	portc,R17
	sbi	porta,DCKIN
WaitInstrACK2:	sbis	pina,DCKOUT
	rjmp	WaitInstrACK2
	out	portc,R18
	cbi	porta,DCKIN
WaitInstrACK3:	sbic	pina,DCKOUT
	rjmp	WaitInstrACK3
	out	portc,R19
	sbi	porta,DCKIN
WaitInstrACK4:	sbis	pina,DCKOUT
	rjmp	WaitInstrACK4
	;
	sbi	porta,RS
	ret
;--------------------------------------------------------------------------------------------
;	odeslat instrukci modulu LCD, nasledne nacist vracene hodnoty
;	(odesle byty R16:R17:R18:R19, nacte vracenou hodnotu do R16:R17)
;--------------------------------------------------------------------------------------------	
LCDtrxInstrCom:	cbi	porta,RS
	;
	out	portc,R16
	cbi	porta,DCKIN
WaitInstrACK5:	sbic	pina,DCKOUT
	rjmp	WaitInstrACK5
	out	portc,R17
	sbi	porta,DCKIN
WaitInstrACK6:	sbis	pina,DCKOUT
	rjmp	WaitInstrACK6
	out	portc,R18
	cbi	porta,DCKIN
WaitInstrACK7:	sbic	pina,DCKOUT
	rjmp	WaitInstrACK7
	out	portc,R19
	sbi	porta,DCKIN
WaitInstrACK8:	sbis	pina,DCKOUT
	rjmp	WaitInstrACK8
	;ted prijem
	ldi	R18,0b00000000
	out	ddrc,R18
WaitInstrACK9:	sbic	pina,DCKOUT
	rjmp	WaitInstrACK9
	in	R16,pinc
	cbi	porta,DCKIN
WaitInstrACK10:	sbis	pina,DCKOUT
	rjmp	WaitInstrACK10
	in	R17,pinc
	sbi	porta,DCKIN
WaitInstrACK11:	sbic	pina,DCKOUT
	rjmp	WaitInstrACK11
	ldi	R18,0b11111111
	out	ddrc,R18
	cbi	porta,DCKIN
WaitInstrACK12:	sbis	pina,DCKOUT
	rjmp	WaitInstrACK12
	sbi	porta,DCKIN
	;
	sbi	porta,RS
	ret
;--------------------------------------------------------------------------------------------
;	pretoci nalezato byty pracovniho radkoveho bufferu a odesle radici LCD
;--------------------------------------------------------------------------------------------
TxDataBuffer:	in	R16,sreg
	push	R16
	cli		;zablokovat preruseni
	
	ldi	R28,low(WorkLineBuffer)
	ldi	R29,high(WorkLineBuffer)	;vstupni buffer k prevraceni
	
	ldi	R16,2	;2 radky po 8 pixelech
	mov	R14,R16
	
LCDtransN4D:	ldi	R30,low(TempBuffer)
	ldi	R31,high(TempBuffer)	;pracovni buffer na 320B
	
	ldi	R25,40	;pro 40 vodorovnych bytu
	
LCDtransN40D:	ld	R16,Y+
	ld	R17,Y+
	ld	R18,Y+
	ld	R19,Y+
	ld	R20,Y+
	ld	R21,Y+
	ld	R22,Y+
	ld	R23,Y+	;nacist 8*8 pixelu
	
	ldi	R24,8	;ted vsech 8B prevratit na bok
LCDtransN8D:	lsr	R16
	rol	R15
	lsr	R17
	rol	R15
	lsr	R18
	rol	R15
	lsr	R19
	rol	R15
	lsr	R20
	rol	R15
	lsr	R21
	rol	R15
	lsr	R22
	rol	R15
	lsr	R23
	rol	R15
	st	Z,R15	;zapamatovat prave prevracenej byte
	adiw	R30,40	;vystupni buffer na dalsi radek
	dec	R24
	brne	LCDtransN8D
	
	subi	R30,low(320-1)
	sbci	R31,high(320-1)	;na zacatek dalsiho sloupce
	
	dec	R25
	brne	LCDtransN40D
	
	;odeslat prave prevracenych 320B
	ldi	R30,low(TempBuffer)
	ldi	R31,high(TempBuffer)
	
	ldi	R21,8
SendNextLnD:	ldi	R20,20
SendNextByteD:	ld	R16,Z+
	out	portc,R16	;byte ven
	cbi	porta,DCKIN	;oznamit data na drate
WaitDataRDack15:	sbic	pina,DCKOUT	;cekat na potvrzeni prijmu
	rjmp	WaitDataRDack15
	ld	R16,Z+
	out	portc,R16	;dalsi byte ven
	sbi	porta,DCKIN	;oznamit dalsi data na drate
WaitDataRDack25:	sbis	pina,DCKOUT
	rjmp	WaitDataRDack25
	dec	R20
	brne	SendNextByteD
	dec	R21
	brne	SendNextLnD
	
	dec	R14
	brne	LCDtransN4D	;dalsich 320B
	
	pop	R16
	out	sreg,R16	;obnovit preruseni
	ret
;--------------------------------------------------------------------------------------------
;	cele LCD na bilo 
;--------------------------------------------------------------------------------------------
LCDclrScrW:	ldi	R16,0b11111111
	rcall	LCDclrScr
	ret
;--------------------------------------------------------------------------------------------
;	cele LCD na cerno (vlastne modro) 
;--------------------------------------------------------------------------------------------
LCDclrScrB:	ldi	R16,0b00000000
	rcall	LCDclrScr
	ret
;--------------------------------------------------------------------------------------------
;	zapise do cele pameti radice byte R16 
;--------------------------------------------------------------------------------------------	
LCDclrScr:	in	R17,sreg
	push	R17
	cli		;zablokovat preruseni
	
	push	R16
	ldi	R16,low(0)
	ldi	R17,high(0)
	rcall	LCDbuffSetPos
	pop	R16
	
	ldi	R21,30
LCSNextLnD:	ldi	R20,160
LCSNextByteD:	out	portc,R16	;byte ven
	cbi	porta,DCKIN	;oznamit data na drate
LCSDataRDack15:	sbic	pina,DCKOUT	;cekat na potvrzeni prijmu
	rjmp	LCSDataRDack15
	out	portc,R16	;dalsi byte ven
	sbi	porta,DCKIN	;oznamit dalsi data na drate
LCSDataRDack25:	sbis	pina,DCKOUT
	rjmp	LCSDataRDack25
	dec	R20
	brne	LCSNextByteD
	dec	R21
	brne	LCSNextLnD
	
	pop	R17
	out	sreg,R17
	ret
	
;*******************************************************************************************
;	rutiny pro generovani textu do line bufferu
;*******************************************************************************************	
;--------------------------------------------------------------------------------------------
;	vymazat obrazovy buffer ImgBuffer1
;--------------------------------------------------------------------------------------------
ClrLineBuffer:	ldi	R28,low(WorkLineBuffer)
	ldi	R29,high(WorkLineBuffer)
	ldi	R16,0b11111111
	ldi	R17,160
ClrLineBuffer1:	st	Y+,R16
	st	Y+,R16
	st	Y+,R16
	st	Y+,R16
	dec	R17
	brne	ClrLineBuffer1
	ldi	R16,low(0)
	ldi	R17,high(0)
	sts	WorkLineBufPTR+0,R16
	sts	WorkLineBufPTR+1,R17
	ret
;--------------------------------------------------------------------------------------------
;	kopirovani znaku velkeho fontu do pracovniho bufferu LCD 
;--------------------------------------------------------------------------------------------
LCDwrChar16buf:	lds	R18,WorkLineBufPTR+0
	lds	R19,WorkLineBufPTR+1
	
	ldi	R30,low(CP1250table10pt*2)
	ldi	R31,high(CP1250table10pt*2)
	clr	R17
	lsl	R16
	rol	R17
	add	R30,R16
	adc	R31,R17	;prekodovani podle CP1250
		
	lpm	R16,Z+
	lpm	R17,Z+
	movw	R30,R16	;adresa hledaneho znaku

	lpm	R17,Z+	;delka znaku	
	adiw	R30,1
		
LCDwrStrFcpCh1:	lpm	R16,Z+
	com	R16
	st	Y+,R16
	lpm	R16,Z+
	com	R16
	st	X+,R16
	
	subi	R18,low(-1)
	sbci	R19,high(-1)
	
	dec	R17
	brne	LCDwrStrFcpCh1	;kopirovat znak do bufferu
	
	ldi	R16,0b11111111
	st	X+,R16
	st	Y+,R16
	
	subi	R18,low(-1)
	sbci	R19,high(-1)
	
	sts	WorkLineBufPTR+0,R18
	sts	WorkLineBufPTR+1,R19
	ret
;--------------------------------------------------------------------------------------------
;	vypise retezec z FLASH od adresy udane Z velkym fontem
;	retezec se ukoncuje 0xFF, radek zalamuje 0x00
;--------------------------------------------------------------------------------------------
LCDwrStrFlash16:	lds	R28,WorkLineBufPTR+0
	lds	R29,WorkLineBufPTR+1
	subi	R28,low(-WorkLineBuffer)
	sbci	R29,high(-WorkLineBuffer)
	movw	R26,R28
	subi	R26,low(-320)
	sbci	R27,high(-320)
	
LCDwrStrFcpTx1:	lpm	R16,Z+	;nacist ASCII znak textu ve FLASH
	
	push	R30
	push	R31
	rcall	LCDwrChar16buf
	pop	R31
	pop	R30
	;
	lpm	R16,Z
	cpi	R16,0xFF
	brne	LCDwrStrFcpTx1
LCDwrStrFcpTx1e:	ret
;-------------------------------------------------------------------------------------------
;	vypsat BCD 16bit
;-------------------------------------------------------------------------------------------
LCDwrBCDcom:	clt
	mov	R16,R15
	andi	R16,0b11110000
	swap	R16
	subi	R16,-48
	cpi	R16,48
	breq	NextNMBR0
	set
	rcall	LCDwrCharBCD
NextNMBR0:	mov	R16,R15
	andi	R16,0b00001111
	subi	R16,-48
	brts	NMBR1
	cpi	R16,48
	breq	NextNMBR1
	set
NMBR1:	rcall	LCDwrCharBCD
NextNMBR1:	mov	R16,R14
	andi	R16,0b11110000
	swap	R16
	subi	R16,-48
	brts	NMBR2
	cpi	R16,48
	breq	NextNMBR2
	set
NMBR2:	rcall	LCDwrCharBCD
NextNMBR2:	mov	R16,R14
	andi	R16,0b00001111
	subi	R16,-48
	brts	NMBR3
	cpi	R16,48
	breq	NextNMBR3
	set
NMBR3:	rcall	LCDwrCharBCD
NextNMBR3:	mov	R16,R13
	andi	R16,0b11110000
	swap	R16
	subi	R16,-48
	brts	NMBR4
	cpi	R16,48
	breq	NextNMBR4
	set
NMBR4:	rcall	LCDwrCharBCD
NextNMBR4:	mov	R16,R13
	andi	R16,0b00001111
	subi	R16,-48
	rcall	LCDwrCharBCD
	ret
;-------------------------------------------------------------------------------------------	
LCDwrCharBCD:	subi	R16,26
	rcall	LCDwrChar16
	ret
;--------------------------------------------------------------------------------------------
;	vypise 1 znak z R16 na LCD velkym fontem
;--------------------------------------------------------------------------------------------
LCDwrChar16:	lds	R28,WorkLineBufPTR+0
	lds	R29,WorkLineBufPTR+1
	subi	R28,low(-WorkLineBuffer)
	sbci	R29,high(-WorkLineBuffer)
	movw	R26,R28
	subi	R26,low(-320)
	sbci	R27,high(-320)
	rcall	LCDwrChar16buf
	ret
	
;*******************************************************************************************
;	matika
;*******************************************************************************************
;------------------------------------------------------------------------------------------------------------------------
; bin2BCD16p5 - 16-bit binary to 5-digit packed BCD conversion (0..65535)
; prevod 16-bit binarniho cisla na peticiferne cislo v BCD
;
; BCD16res0:BCD16res1:BCD16res2 <- bin16r0:bin16r1
;
; words:  29 + ret
; cycles: 29/185 + ret [min/max]
;
; author: Stanislav Maslan, s.maslan@seznam.cz
;------------------------------------------------------------------------------------------------------------------------
	.def	BCD16res0=R13
	.def	BCD16res1=R14
	.def	BCD16res2=R15
	.def	bin16r0=R16
	.def	bin16r1=R17
	.def	BB16_cnt1=R30
	.def	BB16_cnt2=R31

bin2BCD16p5:	ser	BB16_cnt2
	mov	BCD16res2,BB16_cnt2
BB16p5_L10k:	inc	BCD16res2
	subi	bin16r0,low(10000)
	sbci	bin16r1,high(10000)
	brcc	BB16p5_L10k
	subi	bin16r0,low(-10000)
	sbci	bin16r1,high(-10000)
	ldi	BB16_cnt1,(256-16)
BB16p5_L1k:	subi	BB16_cnt1,(-16)
	subi	bin16r0,low(1000)
	sbci	bin16r1,high(1000)
	brcc	BB16p5_L1k
	subi	bin16r0,low(-1000)
	sbci	bin16r1,high(-1000)
	mov	BCD16res1,BB16_cnt2
BB16p5_L100:	inc	BCD16res1
	subi	bin16r0,low(100)
	sbci	bin16r1,high(100)
	brcc	BB16p5_L100
	subi	bin16r0,low(-100)
	or	BCD16res1,BB16_cnt1
	ldi	BB16_cnt1,(256-16)
BB16p5_L10:	subi	BB16_cnt1,(-16)
	subi	bin16r0,10
	brcc	BB16p5_L10
	subi	bin16r0,-10
	mov	BCD16res0,BB16_cnt1
	or	BCD16res0,bin16r0
	ret
;------------------------------------------------------------------------------------------
; div16u - 16/16 bit unsigned division, max. speed optimized
; deleni dvou neznaminkovych 16-bit cisel, maximalni optimalizace na rychlost
;
; editor: Pavel Borovsky, Czech Republic, Europe 3.6.2000
; email: profesor@ti.cz
;
; dDd16r0u:dDd16r1u <- dDd16r0u:dDd16r1u div dDs16r0u:dDs16r1u
; dRe16r0u:dRe16r1u <- dDd16r0u:dDd16r1u mod dDs16r0u:dDs16r1u
;
; words:  142 + ret                        (puvodni od ATMELu: 196 + ret)
; cycles: 126/134/142 + ret [min/avg/max]  (puvodni od ATMELu: 148/172/196 + ret)
;------------------------------------------------------------------------------------------
	.def	dRe16r0u=R14
	.def	dRe16r1u=R15
	.def	dDd16r0u=R16
	.def	dDd16r1u=R17
	.def	dDs16r0u=R18
	.def	dDs16r1u=R19
	;
div16u:	clr	dRe16r0u
	sub	dRe16r1u,dRe16r1u
	rol	dDd16r0u
	rol	dDd16r1u
	rol	dRe16r0u
	sub	dRe16r0u,dDs16r0u
	sbc	dRe16r1u,dDs16r1u
	brcc	d16u_1
	add	dRe16r0u,dDs16r0u
	adc	dRe16r1u,dDs16r1u
d16u_1:	rol	dDd16r0u
	rol	dDd16r1u
	rol	dRe16r0u
	sub	dRe16r0u,dDs16r0u
	sbc	dRe16r1u,dDs16r1u
	brcc	d16u_2
	add	dRe16r0u,dDs16r0u
	adc	dRe16r1u,dDs16r1u
d16u_2:	rol	dDd16r0u
	rol	dDd16r1u
	rol	dRe16r0u
	sub	dRe16r0u,dDs16r0u
	sbc	dRe16r1u,dDs16r1u
	brcc	d16u_3
	add	dRe16r0u,dDs16r0u
	adc	dRe16r1u,dDs16r1u
d16u_3:	rol	dDd16r0u
	rol	dDd16r1u
	rol	dRe16r0u
	sub	dRe16r0u,dDs16r0u
	sbc	dRe16r1u,dDs16r1u
	brcc	d16u_4
	add	dRe16r0u,dDs16r0u
	adc	dRe16r1u,dDs16r1u
d16u_4:	rol	dDd16r0u
	rol	dDd16r1u
	rol	dRe16r0u
	sub	dRe16r0u,dDs16r0u
	sbc	dRe16r1u,dDs16r1u
	brcc	d16u_5
	add	dRe16r0u,dDs16r0u
	adc	dRe16r1u,dDs16r1u
d16u_5:	rol	dDd16r0u
	rol	dDd16r1u
	rol	dRe16r0u
	sub	dRe16r0u,dDs16r0u
	sbc	dRe16r1u,dDs16r1u
	brcc	d16u_6
	add	dRe16r0u,dDs16r0u
	adc	dRe16r1u,dDs16r1u
d16u_6:	rol	dDd16r0u
	rol	dDd16r1u
	rol	dRe16r0u
	sub	dRe16r0u,dDs16r0u
	sbc	dRe16r1u,dDs16r1u
	brcc	d16u_7
	add	dRe16r0u,dDs16r0u
	adc	dRe16r1u,dDs16r1u
d16u_7:	rol	dDd16r0u
	rol	dDd16r1u
	rol	dRe16r0u
	sub	dRe16r0u,dDs16r0u
	sbc	dRe16r1u,dDs16r1u
	brcc	d16u_8
	add	dRe16r0u,dDs16r0u
	adc	dRe16r1u,dDs16r1u
d16u_8:	rol	dDd16r0u
	rol	dDd16r1u
	rol	dRe16r0u
	rol	dRe16r1u
	sub	dRe16r0u,dDs16r0u
	sbc	dRe16r1u,dDs16r1u
	brcc	d16u_9
	add	dRe16r0u,dDs16r0u
	adc	dRe16r1u,dDs16r1u
d16u_9:	rol	dDd16r0u
	rol	dDd16r1u
	rol	dRe16r0u
	rol	dRe16r1u
	sub	dRe16r0u,dDs16r0u
	sbc	dRe16r1u,dDs16r1u
	brcc	d16u_10
	add	dRe16r0u,dDs16r0u
	adc	dRe16r1u,dDs16r1u
d16u_10:	rol	dDd16r0u
	rol	dDd16r1u
	rol	dRe16r0u
	rol	dRe16r1u
	sub	dRe16r0u,dDs16r0u
	sbc	dRe16r1u,dDs16r1u
	brcc	d16u_11
	add	dRe16r0u,dDs16r0u
	adc	dRe16r1u,dDs16r1u
d16u_11:	rol	dDd16r0u
	rol	dDd16r1u
	rol	dRe16r0u
	rol	dRe16r1u
	sub	dRe16r0u,dDs16r0u
	sbc	dRe16r1u,dDs16r1u
	brcc	d16u_12
	add	dRe16r0u,dDs16r0u
	adc	dRe16r1u,dDs16r1u
d16u_12:	rol	dDd16r0u
	rol	dDd16r1u
	rol	dRe16r0u
	rol	dRe16r1u
	sub	dRe16r0u,dDs16r0u
	sbc	dRe16r1u,dDs16r1u
	brcc	d16u_13
	add	dRe16r0u,dDs16r0u
	adc	dRe16r1u,dDs16r1u
d16u_13:	rol	dDd16r0u
	rol	dDd16r1u
	rol	dRe16r0u
	rol	dRe16r1u
	sub	dRe16r0u,dDs16r0u
	sbc	dRe16r1u,dDs16r1u
	brcc	d16u_14
	add	dRe16r0u,dDs16r0u
	adc	dRe16r1u,dDs16r1u
d16u_14:	rol	dDd16r0u
	rol	dDd16r1u
	rol	dRe16r0u
	rol	dRe16r1u
	sub	dRe16r0u,dDs16r0u
	sbc	dRe16r1u,dDs16r1u
	brcc	d16u_15
	add	dRe16r0u,dDs16r0u
	adc	dRe16r1u,dDs16r1u
d16u_15:	rol	dDd16r0u
	rol	dDd16r1u
	rol	dRe16r0u
	rol	dRe16r1u
	sub	dRe16r0u,dDs16r0u
	sbc	dRe16r1u,dDs16r1u
	brcc	d16u_16
	add	dRe16r0u,dDs16r0u
	adc	dRe16r1u,dDs16r1u
d16u_16:	rol	dDd16r0u
	rol	dDd16r1u
	com	dDd16r0u
	com	dDd16r1u
	ret	
;*******************************************************************************************
;	ostatni
;*******************************************************************************************	
	;zpozdeni
DelayLongVar:	clr	R1
	clr	R0
dloop3:	dec	R0
	brne	dloop3
	dec	R1
	brne	dloop3
	dec	R16
	brne	dloop3
	ret
;*******************************************************************************************
;	znakove sady
;*******************************************************************************************
;--------------------------------------------------------------------------------------------
;	Arial 16pix CP1250 proporcionalni 
;--------------------------------------------------------------------------------------------
CP1250table10pt:	.dw	FAr10pt_blank*2	;0
	.dw	FAr10pt_blank*2	;1
	.dw	FAr10pt_blank*2	;2
	.dw	FAr10pt_blank*2	;3
	.dw	FAr10pt_blank*2	;4
	.dw	FAr10pt_blank*2	;5
	.dw	FAr10pt_blank*2	;6
	.dw	FAr10pt_blank*2	;7
	.dw	FAr10pt_blank*2	;8
	.dw	FAr10pt_blank*2	;9
	.dw	FAr10pt_blank*2	;10
	.dw	FAr10pt_blank*2	;11
	.dw	FAr10pt_blank*2	;12
	.dw	FAr10pt_blank*2	;13
	.dw	FAr10pt_blank*2	;14
	.dw	FAr10pt_blank*2	;15
	.dw	FAr10pt_blank*2	;16
	.dw	FAr10pt_blank*2	;17
	.dw	FAr10pt_blank*2	;18
	.dw	FAr10pt_blank*2	;19
	.dw	FAr10pt_blank*2	;20
	.dw	FAr10pt_blank*2	;21
	.dw	FAr10pt_Nm_0*2	;22
	.dw	FAr10pt_Nm_1np*2	;23
	.dw	FAr10pt_Nm_2*2	;24
	.dw	FAr10pt_Nm_3*2	;25
	.dw	FAr10pt_Nm_4*2	;26
	.dw	FAr10pt_Nm_5*2	;27
	.dw	FAr10pt_Nm_6*2	;28
	.dw	FAr10pt_Nm_7*2	;29
	.dw	FAr10pt_Nm_8*2	;30
	.dw	FAr10pt_Nm_9*2	;31
	.dw	FAr10pt_Sp_sp*2
	.dw	FAr10pt_Sp_vikr*2
	.dw	FAr10pt_Sp_uvoz*2
	.dw	FAr10pt_Sp_mriz*2
	.dw	FAr10pt_Sp_dola*2
	.dw	FAr10pt_Sp_proc*2
	.dw	FAr10pt_Sp_and*2
	.dw	FAr10pt_Sp_car1*2
	.dw	FAr10pt_Sp_LKZ*2
	.dw	FAr10pt_Sp_PKZ*2
	.dw	FAr10pt_Sp_krat*2
	.dw	FAr10pt_Sp_plus*2
	.dw	FAr10pt_Sp_cark*2
	.dw	FAr10pt_Sp_minu*2
	.dw	FAr10pt_Sp_teck*2
	.dw	FAr10pt_Sp_nsla*2
	.dw	FAr10pt_Nm_0*2
	.dw	FAr10pt_Nm_1*2
	.dw	FAr10pt_Nm_2*2
	.dw	FAr10pt_Nm_3*2
	.dw	FAr10pt_Nm_4*2
	.dw	FAr10pt_Nm_5*2
	.dw	FAr10pt_Nm_6*2
	.dw	FAr10pt_Nm_7*2
	.dw	FAr10pt_Nm_8*2
	.dw	FAr10pt_Nm_9*2
	.dw	FAr10pt_Sp_dtec*2
	.dw	FAr10pt_Sp_stre*2
	.dw	FAr10pt_Sp_LHS*2
	.dw	FAr10pt_Sp_rovn*2
	.dw	FAr10pt_Sp_PHS*2
	.dw	FAr10pt_Sp_otaz*2
	.dw	FAr10pt_Sp_zavi*2
	.dw	FAr10pt_UC_A*2
	.dw	FAr10pt_UC_B*2
	.dw	FAr10pt_UC_C*2
	.dw	FAr10pt_UC_D*2
	.dw	FAr10pt_UC_E*2
	.dw	FAr10pt_UC_F*2
	.dw	FAr10pt_UC_G*2
	.dw	FAr10pt_UC_H*2
	.dw	FAr10pt_UC_I*2	
	.dw	FAr10pt_UC_J*2
	.dw	FAr10pt_UC_K*2
	.dw	FAr10pt_UC_L*2
	.dw	FAr10pt_UC_M*2
	.dw	FAr10pt_UC_N*2
	.dw	FAr10pt_UC_O*2
	.dw	FAr10pt_UC_P*2
	.dw	FAr10pt_UC_Q*2
	.dw	FAr10pt_UC_R*2
	.dw	FAr10pt_UC_S*2
	.dw	FAr10pt_UC_T*2
	.dw	FAr10pt_UC_U*2
	.dw	FAr10pt_UC_V*2
	.dw	FAr10pt_UC_W*2
	.dw	FAr10pt_UC_X*2
	.dw	FAr10pt_UC_Y*2
	.dw	FAr10pt_UC_Z*2
	.dw	FAr10pt_Sp_LHZ*2
	.dw	FAr10pt_Sp_bsla*2
	.dw	FAr10pt_Sp_PHZ*2
	.dw	FAr10pt_Sp_stri*2
	.dw	FAr10pt_Sp_podt*2
	.dw	FAr10pt_Sp_car2*2
	.dw	FAr10pt_LC_a*2
	.dw	FAr10pt_LC_b*2
	.dw	FAr10pt_LC_c*2
	.dw	FAr10pt_LC_d*2
	.dw	FAr10pt_LC_e*2
	.dw	FAr10pt_LC_f*2
	.dw	FAr10pt_LC_g*2
	.dw	FAr10pt_LC_h*2
	.dw	FAr10pt_LC_i*2
	.dw	FAr10pt_LC_j*2
	.dw	FAr10pt_LC_k*2
	.dw	FAr10pt_LC_l*2
	.dw	FAr10pt_LC_m*2
	.dw	FAr10pt_LC_n*2
	.dw	FAr10pt_LC_o*2
	.dw	FAr10pt_LC_p*2
	.dw	FAr10pt_LC_q*2
	.dw	FAr10pt_LC_r*2
	.dw	FAr10pt_LC_s*2
	.dw	FAr10pt_LC_t*2
	.dw	FAr10pt_LC_u*2
	.dw	FAr10pt_LC_v*2
	.dw	FAr10pt_LC_w*2
	.dw	FAr10pt_LC_x*2
	.dw	FAr10pt_LC_y*2
	.dw	FAr10pt_LC_z*2
	.dw	FAr10pt_Sp_LSZ*2
	.dw	FAr10pt_Sp_svis*2
	.dw	FAr10pt_Sp_PSZ*2
	.dw	FAr10pt_Sp_vlnk*2
	.dw	FAr10pt_blank*2	;127
	.dw	FAr10pt_blank*2	;128
	.dw	FAr10pt_blank*2	;129
	.dw	FAr10pt_blank*2	;130
	.dw	FAr10pt_blank*2	;131
	.dw	FAr10pt_blank*2	;132
	.dw	FAr10pt_blank*2	;133
	.dw	FAr10pt_blank*2	;134
	.dw	FAr10pt_blank*2	;135
	.dw	FAr10pt_blank*2	;136
	.dw	FAr10pt_blank*2	;137
	.dw	FAr10pt_UC_Sh*2
	.dw	FAr10pt_blank*2	;139
	.dw	FAr10pt_blank*2	;140
	.dw	FAr10pt_UC_Th*2
	.dw	FAr10pt_UC_Zh*2
	.dw	FAr10pt_blank*2	;143
	.dw	FAr10pt_blank*2	;144
	.dw	FAr10pt_blank*2	;145
	.dw	FAr10pt_blank*2	;146
	.dw	FAr10pt_blank*2	;147
	.dw	FAr10pt_blank*2	;148
	.dw	FAr10pt_blank*2	;149
	.dw	FAr10pt_blank*2	;150
	.dw	FAr10pt_blank*2	;151
	.dw	FAr10pt_blank*2	;152
	.dw	FAr10pt_blank*2	;153
	.dw	FAr10pt_LC_sh*2
	.dw	FAr10pt_blank*2	;155
	.dw	FAr10pt_blank*2	;156
	.dw	FAr10pt_LC_th*2
	.dw	FAr10pt_LC_zh*2
	.dw	FAr10pt_blank*2	;159
	.dw	FAr10pt_blank*2	;160
	.dw	FAr10pt_Sp_hac1*2
	.dw	FAr10pt_blank*2	;162
	.dw	FAr10pt_blank*2	;163
	.dw	FAr10pt_blank*2	;164
	.dw	FAr10pt_blank*2	;165
	.dw	FAr10pt_blank*2	;166
	.dw	FAr10pt_Sp_para*2
	.dw	FAr10pt_Sp_preh*2
	.dw	FAr10pt_Sp_righ*2
	.dw	FAr10pt_blank*2	;170
	.dw	FAr10pt_blank*2	;171
	.dw	FAr10pt_blank*2	;172
	.dw	FAr10pt_blank*2	;173
	.dw	FAr10pt_blank*2	;174
	.dw	FAr10pt_blank*2	;175
	.dw	FAr10pt_Sp_krou*2
	.dw	FAr10pt_blank*2	;177
	.dw	FAr10pt_blank*2	;178
	.dw	FAr10pt_blank*2	;179
	.dw	FAr10pt_Sp_car3*2
	.dw	FAr10pt_blank*2	;181
	.dw	FAr10pt_blank*2	;182
	.dw	FAr10pt_blank*2	;183
	.dw	FAr10pt_blank*2	;184
	.dw	FAr10pt_blank*2	;185
	.dw	FAr10pt_blank*2	;186
	.dw	FAr10pt_blank*2	;187
	.dw	FAr10pt_blank*2	;188
	.dw	FAr10pt_blank*2	;189
	.dw	FAr10pt_blank*2	;190
	.dw	FAr10pt_blank*2	;191
	.dw	FAr10pt_blank*2	;192
	.dw	FAr10pt_UC_Aa*2
	.dw	FAr10pt_blank*2	;194
	.dw	FAr10pt_blank*2	;195
	.dw	FAr10pt_blank*2
	.dw	FAr10pt_blank*2	;197
	.dw	FAr10pt_blank*2	;198
	.dw	FAr10pt_blank*2	;199
	.dw	FAr10pt_UC_Ch*2
	.dw	FAr10pt_UC_Ee*2
	.dw	FAr10pt_blank*2	;202
	.dw	FAr10pt_blank*2	
	.dw	FAr10pt_UC_Eh*2
	.dw	FAr10pt_UC_Ii*2
	.dw	FAr10pt_blank*2	;206
	.dw	FAr10pt_UC_Dh*2
	.dw	FAr10pt_blank*2	;208
	.dw	FAr10pt_blank*2	;209
	.dw	FAr10pt_UC_Nh*2
	.dw	FAr10pt_UC_Oo*2
	.dw	FAr10pt_blank*2	;212
	.dw	FAr10pt_blank*2	;213
	.dw	FAr10pt_blank*2
	.dw	FAr10pt_blank*2	;215
	.dw	FAr10pt_UC_Rh*2
	.dw	FAr10pt_UC_Uk*2
	.dw	FAr10pt_UC_Uu*2
	.dw	FAr10pt_blank*2	;219
	.dw	FAr10pt_blank*2
	.dw	FAr10pt_UC_Yy*2
	.dw	FAr10pt_blank*2	;222
	.dw	FAr10pt_blank*2	;223
	.dw	FAr10pt_blank*2	;224
	.dw	FAr10pt_LC_aa*2
	.dw	FAr10pt_blank*2	;226
	.dw	FAr10pt_blank*2	;227
	.dw	FAr10pt_blank*2
	.dw	FAr10pt_UC_Ii*2	;229
	.dw	FAr10pt_blank*2	;230
	.dw	FAr10pt_blank*2	;231
	.dw	FAr10pt_LC_ch*2
	.dw	FAr10pt_LC_ee*2
	.dw	FAr10pt_blank*2	;234
	.dw	FAr10pt_blank*2
	.dw	FAr10pt_LC_eh*2
	.dw	FAr10pt_LC_ii*2
	.dw	FAr10pt_blank*2	;238
	.dw	FAr10pt_LC_dh*2
	.dw	FAr10pt_blank*2	;240
	.dw	FAr10pt_blank*2	;241
	.dw	FAr10pt_LC_nh*2
	.dw	FAr10pt_LC_oo*2
	.dw	FAr10pt_blank*2	;244
	.dw	FAr10pt_blank*2	;245
	.dw	FAr10pt_blank*2
	.dw	FAr10pt_blank*2	;247
	.dw	FAr10pt_LC_rh*2
	.dw	FAr10pt_LC_uk*2
	.dw	FAr10pt_LC_uu*2
	.dw	FAr10pt_blank*2	;251
	.dw	FAr10pt_blank*2
	.dw	FAr10pt_LC_yy*2
	.dw	FAr10pt_blank*2	;254
	.dw	FAr10pt_blank*2	;255	

FAr10pt_blank:	.dw	5
	.dw	0b1111111111111110
	.dw	0b1111111111011110
	.dw	0b1110100111101110
	.dw	0b1111111000011110
	.dw	0b1111111111111110	
FAr10pt_LC_a:	.dw	5	;delka
	.dw	0b0000110010000000
	.dw	0b0001001001000000
	.dw	0b0001001001000000
	.dw	0b0000101001000000
	.dw	0b0001111110000000
FAr10pt_LC_b:	.dw	5	;delka
	.dw	0b0001111111111000
	.dw	0b0001000010000000
	.dw	0b0001000001000000
	.dw	0b0001000001000000
	.dw	0b0000111110000000
FAr10pt_LC_c:	.dw	5	;delka
	.dw	0b0000111110000000
	.dw	0b0001000001000000
	.dw	0b0001000001000000
	.dw	0b0001000001000000
	.dw	0b0000100010000000
FAr10pt_LC_d:	.dw	5	;delka
	.dw	0b0000111110000000
	.dw	0b0001000001000000
	.dw	0b0001000001000000
	.dw	0b0001000010000000
	.dw	0b0001111111111000
FAr10pt_LC_e:	.dw	5	;delka
	.dw	0b0000111110000000
	.dw	0b0001001001000000
	.dw	0b0001001001000000
	.dw	0b0001001001000000
	.dw	0b0000101110000000
FAr10pt_LC_f:	.dw	4	;delka
	.dw	0b0000000001000000
	.dw	0b0001111111110000
	.dw	0b0000000001001000
	.dw	0b0000000000001000
FAr10pt_LC_g:	.dw	5	;delka
	.dw	0b0100111110000000
	.dw	0b1001000001000000
	.dw	0b1001000001000000
	.dw	0b1000100010000000
	.dw	0b0111111111000000
FAr10pt_LC_h:	.dw	5	;delka
	.dw	0b0001111111111000
	.dw	0b0000000010000000
	.dw	0b0000000001000000
	.dw	0b0000000001000000
	.dw	0b0001111110000000
FAr10pt_LC_i:	.dw	1	;delka
	.dw	0b0001111111001000
FAr10pt_LC_j:	.dw	3	;delka
	.dw	0b1000000000000000
	.dw	0b1000000000000000
	.dw	0b0111111111001000
FAr10pt_LC_k:	.dw	5	;delka
	.dw	0b0001111111111000
	.dw	0b0000001000000000
	.dw	0b0000010100000000
	.dw	0b0000100010000000
	.dw	0b0001000001000000
FAr10pt_LC_l:	.dw	1	;delka
	.dw	0b0001111111111000
FAr10pt_LC_m:	.dw	9	;delka
	.dw	0b0001111111000000
	.dw	0b0000000010000000
	.dw	0b0000000001000000
	.dw	0b0000000001000000
	.dw	0b0001111110000000
	.dw	0b0000000010000000
	.dw	0b0000000001000000
	.dw	0b0000000001000000
	.dw	0b0001111110000000
FAr10pt_LC_n:	.dw	5	;delka
	.dw	0b0001111111000000
	.dw	0b0000000010000000
	.dw	0b0000000001000000
	.dw	0b0000000001000000
	.dw	0b0001111110000000
FAr10pt_LC_o:	.dw	5	;delka
	.dw	0b0000111110000000
	.dw	0b0001000001000000
	.dw	0b0001000001000000
	.dw	0b0001000001000000
	.dw	0b0000111110000000
FAr10pt_LC_p:	.dw	5	;delka
	.dw	0b1111111111000000
	.dw	0b0000100010000000
	.dw	0b0001000001000000
	.dw	0b0001000001000000
	.dw	0b0000111110000000
FAr10pt_LC_q:	.dw	5	;delka
	.dw	0b0000111110000000
	.dw	0b0001000001000000
	.dw	0b0001000001000000
	.dw	0b0000100010000000
	.dw	0b1111111111000000
FAr10pt_LC_r:	.dw	3	;delka
	.dw	0b0001111111000000
	.dw	0b0000000010000000
	.dw	0b0000000001000000
FAr10pt_LC_s:	.dw	5	;delka
	.dw	0b0000100110000000
	.dw	0b0001001001000000
	.dw	0b0001001001000000
	.dw	0b0001001001000000
	.dw	0b0000110010000000
FAr10pt_LC_t:	.dw	3	;delka
	.dw	0b0000000001000000
	.dw	0b0001111111110000
	.dw	0b0001000001000000
FAr10pt_LC_u:	.dw	5	;delka
	.dw	0b0000111111000000
	.dw	0b0001000000000000
	.dw	0b0001000000000000
	.dw	0b0001000000000000
	.dw	0b0001111111000000
FAr10pt_LC_v:	.dw	5	;delka
	.dw	0b0000000011000000
	.dw	0b0000011100000000
	.dw	0b0001100000000000
	.dw	0b0000011100000000
	.dw	0b0000000011000000
FAr10pt_LC_w:	.dw	9	;delka
	.dw	0b0000000011000000
	.dw	0b0000011100000000
	.dw	0b0001100000000000
	.dw	0b0000011100000000
	.dw	0b0000000011000000
	.dw	0b0000011100000000
	.dw	0b0001100000000000
	.dw	0b0000011100000000
	.dw	0b0000000011000000
FAr10pt_LC_x:	.dw	5	;delka
	.dw	0b0001100011000000
	.dw	0b0000010100000000
	.dw	0b0000001000000000
	.dw	0b0000010100000000
	.dw	0b0001100011000000
FAr10pt_LC_y:	.dw	5	;delka
	.dw	0b1000000011000000
	.dw	0b1000011100000000
	.dw	0b0111100000000000
	.dw	0b0000011100000000
	.dw	0b0000000011000000
FAr10pt_LC_z:	.dw	5	;delka
	.dw	0b0001100001000000
	.dw	0b0001010001000000
	.dw	0b0001001001000000
	.dw	0b0001000101000000
	.dw	0b0001000011000000
FAr10pt_UC_A:	.dw	7	;delka
	.dw	0b0001110000000000
	.dw	0b0000001110000000
	.dw	0b0000001001110000
	.dw	0b0000001000001000
	.dw	0b0000001001110000
	.dw	0b0000001110000000
	.dw	0b0001110000000000
FAr10pt_UC_B:	.dw	6	;delka
	.dw	0b0001111111111000
	.dw	0b0001000010001000
	.dw	0b0001000010001000
	.dw	0b0001000010001000
	.dw	0b0001000010001000
	.dw	0b0000111101110000
FAr10pt_UC_C:	.dw	6	;delka
	.dw	0b0000011111100000
	.dw	0b0000100000010000
	.dw	0b0001000000001000
	.dw	0b0001000000001000
	.dw	0b0001000000001000
	.dw	0b0000100000010000
FAr10pt_UC_D:	.dw	6	;delka
	.dw	0b0001111111111000
	.dw	0b0001000000001000
	.dw	0b0001000000001000
	.dw	0b0001000000001000
	.dw	0b0000100000010000
	.dw	0b0000011111100000
FAr10pt_UC_E:	.dw	6	;delka
	.dw	0b0001111111111000
	.dw	0b0001000010001000
	.dw	0b0001000010001000
	.dw	0b0001000010001000
	.dw	0b0001000010001000
	.dw	0b0001000000001000
FAr10pt_UC_F:	.dw	6	;delka
	.dw	0b0001111111111000
	.dw	0b0000000010001000
	.dw	0b0000000010001000
	.dw	0b0000000010001000
	.dw	0b0000000010001000
	.dw	0b0000000000001000
FAr10pt_UC_G:	.dw	6	;delka
	.dw	0b0000011111100000
	.dw	0b0000100000010000
	.dw	0b0001000000001000
	.dw	0b0001000100001000
	.dw	0b0001000100001000
	.dw	0b0000111100010000
FAr10pt_UC_H:	.dw	6	;delka
	.dw	0b0001111111111000
	.dw	0b0000000010000000
	.dw	0b0000000010000000
	.dw	0b0000000010000000
	.dw	0b0000000010000000
	.dw	0b0001111111111000
FAr10pt_UC_I:	.dw	1	;delka
	.dw	0b0001111111111000
FAr10pt_UC_J:	.dw	4	;delka
	.dw	0b0000100000000000
	.dw	0b0001000000000000
	.dw	0b0001000000000000
	.dw	0b0000111111111000
FAr10pt_UC_K:	.dw	6	;delka
	.dw	0b0001111111111000
	.dw	0b0000000010000000
	.dw	0b0000000011000000
	.dw	0b0000001100100000
	.dw	0b0000110000010000
	.dw	0b0001000000001000
FAr10pt_UC_L:	.dw	5	;delka
	.dw	0b0001111111111000
	.dw	0b0001000000000000
	.dw	0b0001000000000000
	.dw	0b0001000000000000
	.dw	0b0001000000000000
FAr10pt_UC_M:	.dw	7	;delka
	.dw	0b0001111111111000
	.dw	0b0000000000110000
	.dw	0b0000000011000000
	.dw	0b0000001100000000
	.dw	0b0000000011000000
	.dw	0b0000000000110000
	.dw	0b0001111111111000
FAr10pt_UC_N:	.dw	6	;delka
	.dw	0b0001111111111000
	.dw	0b0000000000110000
	.dw	0b0000000011000000
	.dw	0b0000001100000000
	.dw	0b0000110000000000
	.dw	0b0001111111111000
FAr10pt_UC_O:	.dw	7	;delka
	.dw	0b0000011111100000
	.dw	0b0000100000010000
	.dw	0b0001000000001000
	.dw	0b0001000000001000
	.dw	0b0001000000001000
	.dw	0b0000100000010000
	.dw	0b0000011111100000
FAr10pt_UC_P:	.dw	6	;delka
	.dw	0b0001111111111000
	.dw	0b0000000100001000
	.dw	0b0000000100001000
	.dw	0b0000000100001000
	.dw	0b0000000100001000
	.dw	0b0000000011110000
FAr10pt_UC_Q:	.dw	7	;delka
	.dw	0b0000011111100000
	.dw	0b0000100000010000
	.dw	0b0001000000001000
	.dw	0b0001000000001000
	.dw	0b0001010000001000
	.dw	0b0000100000010000
	.dw	0b0001011111100000
FAr10pt_UC_R:	.dw	6	;delka
	.dw	0b0001111111111000
	.dw	0b0000000100001000
	.dw	0b0000001100001000
	.dw	0b0000010100001000
	.dw	0b0000100100001000
	.dw	0b0001000011110000
FAr10pt_UC_S:	.dw	6	;delka
	.dw	0b0000100001110000
	.dw	0b0001000010001000
	.dw	0b0001000010001000
	.dw	0b0001000010001000
	.dw	0b0001000010001000
	.dw	0b0000111100010000
FAr10pt_UC_T:	.dw	5	;delka
	.dw	0b0000000000001000
	.dw	0b0000000000001000
	.dw	0b0001111111111000
	.dw	0b0000000000001000
	.dw	0b0000000000001000
FAr10pt_UC_U:	.dw	6	;delka
	.dw	0b0000111111111000
	.dw	0b0001000000000000
	.dw	0b0001000000000000
	.dw	0b0001000000000000
	.dw	0b0001000000000000
	.dw	0b0000111111111000
FAr10pt_UC_V:	.dw	7	;delka
	.dw	0b0000000001111000
	.dw	0b0000000110000000
	.dw	0b0000011000000000
	.dw	0b0001100000000000
	.dw	0b0000011000000000
	.dw	0b0000000110000000
	.dw	0b0000000001111000
FAr10pt_UC_W:	.dw	9	;delka
	.dw	0b0000000001111000
	.dw	0b0000001110000000
	.dw	0b0001110000000000
	.dw	0b0000001110000000
	.dw	0b0000000001110000
	.dw	0b0000001110000000
	.dw	0b0001110000000000
	.dw	0b0000001110000000
	.dw	0b0000000001111000
FAr10pt_UC_X:	.dw	5	;delka
	.dw	0b0001100000011000
	.dw	0b0000011001100000
	.dw	0b0000000110000000
	.dw	0b0000011001100000
	.dw	0b0001100000011000
FAr10pt_UC_Y:	.dw	5	;delka
	.dw	0b0000000000011000
	.dw	0b0000000001100000
	.dw	0b0001111110000000
	.dw	0b0000000001100000
	.dw	0b0000000000011000
FAr10pt_UC_Z:	.dw	6	;delka
	.dw	0b0001000000001000
	.dw	0b0001110000001000
	.dw	0b0001001100001000
	.dw	0b0001000011001000
	.dw	0b0001000000111000
	.dw	0b0001000000001000

	
FAr10pt_LC_aa:	.dw	5	;delka
	.dw	0b0000110010000000
	.dw	0b0001001001000000
	.dw	0b0001001001010000
	.dw	0b0000101001001000
	.dw	0b0001111110000000
FAr10pt_LC_ch:	.dw	5	;delka
	.dw	0b0000111110000000
	.dw	0b0001000001001000
	.dw	0b0001000001010000
	.dw	0b0001000001001000
	.dw	0b0000100010000000
FAr10pt_LC_dh:	.dw	7	;delka
	.dw	0b0000111110000000
	.dw	0b0001000001000000
	.dw	0b0001000001000000
	.dw	0b0001000010000000
	.dw	0b0001111111111000
	.dw	0b0000000000000000
	.dw	0b0000000000111000
FAr10pt_LC_ee:	.dw	5	;delka
	.dw	0b0000111110000000
	.dw	0b0001001001000000
	.dw	0b0001001001010000
	.dw	0b0001001001001000
	.dw	0b0000101110000000
FAr10pt_LC_eh:	.dw	5	;delka
	.dw	0b0000111110000000
	.dw	0b0001001001001000
	.dw	0b0001001001010000
	.dw	0b0001001001001000
	.dw	0b0000101110000000	
FAr10pt_LC_ii:	.dw	2	;delka
	.dw	0b0001111111010000
	.dw	0b0000000000001000
FAr10pt_LC_oo:	.dw	5	;delka
	.dw	0b0000111110000000
	.dw	0b0001000001000000
	.dw	0b0001000001010000
	.dw	0b0001000001001000
	.dw	0b0000111110000000
FAr10pt_LC_nh:	.dw	5	;delka
	.dw	0b0001111111000000
	.dw	0b0000000010001000
	.dw	0b0000000001010000
	.dw	0b0000000001001000
	.dw	0b0001111110000000
FAr10pt_LC_rh:	.dw	3	;delka
	.dw	0b0001111111001000
	.dw	0b0000000010010000
	.dw	0b0000000001001000
FAr10pt_LC_sh:	.dw	5	;delka
	.dw	0b0000100110000000
	.dw	0b0001001001001000
	.dw	0b0001001001010000
	.dw	0b0001001001001000
	.dw	0b0000110010000000
FAr10pt_LC_th:	.dw	4	;delka
	.dw	0b0000000001000000
	.dw	0b0001111111110000
	.dw	0b0001000001000000
	.dw	0b0000000000011100
FAr10pt_LC_uu:	.dw	5	;delka
	.dw	0b0000111111000000
	.dw	0b0001000000000000
	.dw	0b0001000000010000
	.dw	0b0001000000001000
	.dw	0b0001111111000000
FAr10pt_LC_uk:	.dw	5	;delka
	.dw	0b0000111111000000
	.dw	0b0001000000001000
	.dw	0b0001000000010100
	.dw	0b0001000000001000
	.dw	0b0001111111000000
FAr10pt_LC_yy:	.dw	5	;delka
	.dw	0b1000000011000000
	.dw	0b1000011100000000
	.dw	0b0111100000010000
	.dw	0b0000011100001000
	.dw	0b0000000011000000
FAr10pt_LC_zh:	.dw	5	;delka
	.dw	0b0001100001000000
	.dw	0b0001010001001000
	.dw	0b0001001001010000
	.dw	0b0001000101001000
	.dw	0b0001000011000000
FAr10pt_UC_Aa:	.dw	7	;delka
	.dw	0b0001110000000000
	.dw	0b0000001110000000
	.dw	0b0000001001110000
	.dw	0b0000001000001100
	.dw	0b0000001001110010
	.dw	0b0000001110000000
	.dw	0b0001110000000000	
FAr10pt_UC_Ch:	.dw	6	;delka
	.dw	0b0000011111100000
	.dw	0b0000100000010000
	.dw	0b0001000000001010
	.dw	0b0001000000001100
	.dw	0b0001000000001010
	.dw	0b0000100000010000	
FAr10pt_UC_Dh:	.dw	6	;delka
	.dw	0b0001111111111000
	.dw	0b0001000000001010
	.dw	0b0001000000001100
	.dw	0b0001000000001010
	.dw	0b0000100000010000
	.dw	0b0000011111100000	
FAr10pt_UC_Ee:	.dw	6	;delka
	.dw	0b0001111111111000
	.dw	0b0001000010001000
	.dw	0b0001000010001100
	.dw	0b0001000010001010
	.dw	0b0001000010001000
	.dw	0b0001000000001000
FAr10pt_UC_Eh:	.dw	6	;delka
	.dw	0b0001111111111000
	.dw	0b0001000010001000
	.dw	0b0001000010001010
	.dw	0b0001000010001100
	.dw	0b0001000010001010
	.dw	0b0001000000001000	
FAr10pt_UC_Ii:	.dw	2	;delka
	.dw	0b0001111111111100
	.dw	0b0000000000000010	
FAr10pt_UC_Oo:	.dw	7	;delka
	.dw	0b0000011111100000
	.dw	0b0000100000010000
	.dw	0b0001000000001000
	.dw	0b0001000000001100
	.dw	0b0001000000001010
	.dw	0b0000100000010000
	.dw	0b0000011111100000
FAr10pt_UC_Nh:	.dw	6	;delka
	.dw	0b0001111111111000
	.dw	0b0000000000110000
	.dw	0b0000000011000010
	.dw	0b0000001100000100
	.dw	0b0000110000000010
	.dw	0b0001111111111000
FAr10pt_UC_Rh:	.dw	6	;delka
	.dw	0b0001111111111000
	.dw	0b0000000100001010
	.dw	0b0000001100001100
	.dw	0b0000010100001010
	.dw	0b0000100100001000
	.dw	0b0001000011110000
FAr10pt_UC_Sh:	.dw	6	;delka
	.dw	0b0000100001110000
	.dw	0b0001000010001000
	.dw	0b0001000010001010
	.dw	0b0001000010001100
	.dw	0b0001000010001010
	.dw	0b0000111100010000
FAr10pt_UC_Th:	.dw	5	;delka
	.dw	0b0000000000001000
	.dw	0b0000000000001010
	.dw	0b0001111111111100
	.dw	0b0000000000001010
	.dw	0b0000000000001000
FAr10pt_UC_Uu:	.dw	6	;delka
	.dw	0b0000111111111000
	.dw	0b0001000000000000
	.dw	0b0001000000000100
	.dw	0b0001000000000010
	.dw	0b0001000000000000
	.dw	0b0000111111111000
FAr10pt_UC_Uk:	.dw	6	;delka
	.dw	0b0000111111111000
	.dw	0b0001000000000000
	.dw	0b0001000000000010
	.dw	0b0001000000000101
	.dw	0b0001000000000010
	.dw	0b0000111111111000
FAr10pt_UC_Yy:	.dw	5	;delka
	.dw	0b0000000000011000
	.dw	0b0000000001100000
	.dw	0b0001111110000100
	.dw	0b0000000001100010
	.dw	0b0000000000011000
FAr10pt_UC_Zh:	.dw	6	;delka
	.dw	0b0001000000001000
	.dw	0b0001110000001000
	.dw	0b0001001100001010
	.dw	0b0001000011001100
	.dw	0b0001000000111010
	.dw	0b0001000000001000			
	
	
	
	
FAr10pt_Nm_1np:	.dw	6	;delka
	.dw	0b0000000000000000
	.dw	0b0000000000100000
	.dw	0b0000000000010000
	.dw	0b0001111111111000
	.dw	0b0000000000000000
	.dw	0b0000000000000000
FAr10pt_Nm_0:	.dw	6	;delka
	.dw	0b0000111111110000
	.dw	0b0001000000001000
	.dw	0b0001000000001000
	.dw	0b0001000000001000
	.dw	0b0001000000001000
	.dw	0b0000111111110000
FAr10pt_Nm_1:	.dw	4	;delka
	.dw	0b0000000000100000
	.dw	0b0000000000010000
	.dw	0b0001111111111000
	.dw	0b0000000000000000
FAr10pt_Nm_2:	.dw	6	;delka
	.dw	0b0001000000010000
	.dw	0b0001100000001000
	.dw	0b0001010000001000
	.dw	0b0001001000001000
	.dw	0b0001000100001000
	.dw	0b0001000011110000
FAr10pt_Nm_3:	.dw	6	;delka
	.dw	0b0000100000010000
	.dw	0b0001000000001000
	.dw	0b0001000010001000
	.dw	0b0001000010001000
	.dw	0b0001000010001000
	.dw	0b0000111101110000
FAr10pt_Nm_4:	.dw	6	;delka
	.dw	0b0000010000000000
	.dw	0b0000011100000000
	.dw	0b0000010011000000
	.dw	0b0000010000110000
	.dw	0b0001111111111000
	.dw	0b0000010000000000
FAr10pt_Nm_5:	.dw	6	;delka
	.dw	0b0000100111111000
	.dw	0b0001000010001000
	.dw	0b0001000010001000
	.dw	0b0001000010001000
	.dw	0b0001000010001000
	.dw	0b0000111100001000
FAr10pt_Nm_6:	.dw	6	;delka
	.dw	0b0000111111110000
	.dw	0b0001000100001000
	.dw	0b0001000010001000
	.dw	0b0001000010001000
	.dw	0b0001000010001000
	.dw	0b0000111100010000
FAr10pt_Nm_7:	.dw	6	;delka
	.dw	0b0000000000001000
	.dw	0b0001110000001000
	.dw	0b0000001100001000
	.dw	0b0000000011001000
	.dw	0b0000000000111000
	.dw	0b0000000000001000
FAr10pt_Nm_8:	.dw	6	;delka
	.dw	0b0000111101110000
	.dw	0b0001000010001000
	.dw	0b0001000010001000
	.dw	0b0001000010001000
	.dw	0b0001000010001000
	.dw	0b0000111101110000
FAr10pt_Nm_9:	.dw	6	;delka
	.dw	0b0000100011110000
	.dw	0b0001000100001000
	.dw	0b0001000100001000
	.dw	0b0001000100001000
	.dw	0b0001000010001000
	.dw	0b0000111111110000


	
FAr10pt_Sp_sp:	.dw	2
	.dw	0b0000000000000000
	.dw	0b0000000000000000
FAr10pt_Sp_vikr:	.dw	1
	.dw	0b0001011111111000
FAr10pt_Sp_zavi:	.dw	12
	.dw	0b0001111110000000
	.dw	0b0010000001100000
	.dw	0b0100000000010000
	.dw	0b1000111100010000
	.dw	0b1001000010001000
	.dw	0b1001000001001000
	.dw	0b1001000001001000
	.dw	0b1000100010001000
	.dw	0b1001111111001000
	.dw	0b0101000000010000
	.dw	0b0100110000100000
	.dw	0b0010001111000000
FAr10pt_Sp_mriz:	.dw	8
	.dw	0b0000001001000000
	.dw	0b0001111001000000
	.dw	0b0000001111000000
	.dw	0b0000001001111000
	.dw	0b0001111001000000
	.dw	0b0000001111000000
	.dw	0b0000001001111000
	.dw	0b0000001001000000
FAr10pt_Sp_dola:	.dw	5
	.dw	0b0000100001110000
	.dw	0b0001000010001000
	.dw	0b0011111111111100
	.dw	0b0001000010001000
	.dw	0b0000111100010000
FAr10pt_Sp_proc:	.dw	8
	.dw	0b0000000000110000
	.dw	0b0001000001001000
	.dw	0b0000110001001000
	.dw	0b0000001100110000
	.dw	0b0000110011000000
	.dw	0b0001001000110000
	.dw	0b0001001000001000
	.dw	0b0000110000000000
FAr10pt_Sp_stri:	.dw	5
	.dw	0b0000000000100000
	.dw	0b0000000000010000
	.dw	0b0000000000001000
	.dw	0b0000000000010000
	.dw	0b0000000000100000
FAr10pt_Sp_and:	.dw	8
	.dw	0b0000111000000000
	.dw	0b0001000101110000
	.dw	0b0001000110001000
	.dw	0b0001001010001000
	.dw	0b0000110001110000
	.dw	0b0000100000000000
	.dw	0b0001011000000000
	.dw	0b0001000000000000
FAr10pt_Sp_krat:	.dw	5
	.dw	0b0000001001000000
	.dw	0b0000000110000000
	.dw	0b0000011111100000
	.dw	0b0000000110000000
	.dw	0b0000001001000000
FAr10pt_Sp_LKZ:	.dw	3
	.dw	0b0000011111100000
	.dw	0b0001100000011000
	.dw	0b0010000000000100
FAr10pt_Sp_PKZ:	.dw	3
	.dw	0b0010000000000100
	.dw	0b0001100000011000
	.dw	0b0000011111100000
FAr10pt_Sp_LHZ:	.dw	2
	.dw	0b0011111111111100
	.dw	0b0010000000000100
FAr10pt_Sp_PHZ:	.dw	2
	.dw	0b0010000000000100
	.dw	0b0011111111111100
FAr10pt_Sp_LSZ:	.dw	3
	.dw	0b0000000110000000
	.dw	0b0001111001111000
	.dw	0b0010000000000100
FAr10pt_Sp_PSZ:	.dw	3
	.dw	0b0010000000000100
	.dw	0b0001111001111000
	.dw	0b0000000110000000
FAr10pt_Sp_svis:	.dw	1
	.dw	0b0011111111111100
FAr10pt_Sp_plus:	.dw	5
	.dw	0b0000000100000000
	.dw	0b0000000100000000
	.dw	0b0000011111000000
	.dw	0b0000000100000000
	.dw	0b0000000100000000
FAr10pt_Sp_minu:	.dw	5
	.dw	0b0000000100000000
	.dw	0b0000000100000000
	.dw	0b0000000100000000
	.dw	0b0000000100000000
	.dw	0b0000000100000000
FAr10pt_Sp_rovn:	.dw	4
	.dw	0b0000001010000000
	.dw	0b0000001010000000
	.dw	0b0000001010000000
	.dw	0b0000001010000000
FAr10pt_Sp_podt:	.dw	5
	.dw	0b0001000000000000
	.dw	0b0001000000000000
	.dw	0b0001000000000000
	.dw	0b0001000000000000
	.dw	0b0001000000000000
FAr10pt_Sp_bsla:	.dw	4
	.dw	0b0000000000011000
	.dw	0b0000000011100000
	.dw	0b0000011100000000
	.dw	0b0001100000000000
FAr10pt_Sp_nsla:	.dw	4
	.dw	0b0001100000000000
	.dw	0b0000011100000000
	.dw	0b0000000011100000
	.dw	0b0000000000011000
FAr10pt_Sp_dtec:	.dw	2
	.dw	0b0001100011000000
	.dw	0b0001100011000000
FAr10pt_Sp_stre:	.dw	2
	.dw	0b0101100011000000
	.dw	0b0011100011000000
FAr10pt_Sp_cark:	.dw	2
	.dw	0b0101100000000000
	.dw	0b0011100000000000
FAr10pt_Sp_teck:	.dw	2
	.dw	0b0001100000000000
	.dw	0b0001100000000000
FAr10pt_Sp_uvoz:	.dw	3
	.dw	0b0000000000111000
	.dw	0b0000000000000000
	.dw	0b0000000000111000
FAr10pt_Sp_car1:	.dw	1
	.dw	0b0000000000111000
FAr10pt_Sp_car2:	.dw	2
	.dw	0b0000000000001000
	.dw	0b0000000000010000
FAr10pt_Sp_car3:	.dw	2
	.dw	0b0000000000000100
	.dw	0b0000000000000010
FAr10pt_Sp_hac1:	.dw	3
	.dw	0b0000000000000010
	.dw	0b0000000000000100
	.dw	0b0000000000000010
FAr10pt_Sp_LHS:	.dw	5
	.dw	0b0000000100000000
	.dw	0b0000001010000000
	.dw	0b0000010001000000
	.dw	0b0000100000100000
	.dw	0b0001000000010000
FAr10pt_Sp_PHS:	.dw	5
	.dw	0b0001000000010000
	.dw	0b0000100000100000
	.dw	0b0000010001000000
	.dw	0b0000001010000000
	.dw	0b0000000100000000
FAr10pt_Sp_otaz:	.dw	5
	.dw	0b0000000000110000
	.dw	0b0000000000001000
	.dw	0b0001011000001000
	.dw	0b0000000110001000
	.dw	0b0000000001110000
FAr10pt_Sp_vlnk:	.dw	7
	.dw	0b0000001000000000
	.dw	0b0000000100000000
	.dw	0b0000000010000000
	.dw	0b0000000100000000
	.dw	0b0000001000000000
	.dw	0b0000000100000000
	.dw	0b0000000010000000
FAr10pt_Sp_krou:	.dw	4
	.dw	0b0000000000110000
	.dw	0b0000000001001000
	.dw	0b0000000001001000
	.dw	0b0000000000110000
FAr10pt_Sp_preh:	.dw	3
	.dw	0b0000000000010000
	.dw	0b0000000000000000
	.dw	0b0000000000010000
FAr10pt_Sp_para:	.dw	5
	.dw	0b0000100011100000
	.dw	0b0001000100011100
	.dw	0b0001001000010010
	.dw	0b0000111000100010
	.dw	0b0000000111000100
FAr10pt_Sp_righ:	.dw	10
	.dw	0b0000001111000000
	.dw	0b0000010000100000
	.dw	0b0000100000010000
	.dw	0b0001001111001000
	.dw	0b0001010000101000
	.dw	0b0001010000101000
	.dw	0b0001001001001000
	.dw	0b0000100000010000
	.dw	0b0000010000100000
	.dw	0b0000001111000000	